/* -- THIS FILE IS GENERATED - DO NOT EDIT *//* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 3 "gedit.override"
#include <pygobject.h>
#include <pygtk/pygtk.h>

#include <gedit/gedit-language-manager.h>
#include <gedit/gedit-plugin.h>
#include <gedit/gedit-app.h>
#include <gedit/gedit-encodings.h>
#include <gedit/gedit-enum-types.h>
#include <gedit/gedit-statusbar.h>
#include <gedit/gedit-debug.h>
#include <gedit/gedit-help.h>

#include "gedit-plugin-python.h"

void pygedit_register_classes (PyObject *d); 
void pygedit_add_constants (PyObject *module, const gchar *strip_prefix);

static PyObject *
_helper_wrap_gobject_glist (const GList *list)
{
    PyObject *py_list;
    const GList *tmp;

    if ((py_list = PyList_New(0)) == NULL) {
        return NULL;
    }
    for (tmp = list; tmp != NULL; tmp = tmp->next) {
        PyObject *py_obj = pygobject_new(G_OBJECT(tmp->data));

        if (py_obj == NULL) {
            Py_DECREF(py_list);
            return NULL;
        }
        PyList_Append(py_list, py_obj);
        Py_DECREF(py_obj);
    }
    return py_list;
}

static PyObject *
_helper_wrap_gobject_gslist (const GSList *list)
{
    PyObject *py_list;
    const GSList *tmp;

    if ((py_list = PyList_New(0)) == NULL) {
        return NULL;
    }
    for (tmp = list; tmp != NULL; tmp = tmp->next) {
        PyObject *py_obj = pygobject_new(G_OBJECT(tmp->data));

        if (py_obj == NULL) {
            Py_DECREF(py_list);
            return NULL;
        }
        PyList_Append(py_list, py_obj);
        Py_DECREF(py_obj);
    }
    return py_list;
}

#line 3 "geditplugin.override"
#include <gedit/gedit-plugin.h>
#include <gedit/gedit-window.h>

#line 3 "geditmessage.override"

#include <gedit/gedit-message-bus.h>
#include <gedit/gedit-message.h>

static GType
_helper_wrap_get_gtype_from_pytype (PyObject *pytype)
{
    PyTypeObject *type = (PyTypeObject *)pytype;
    
    if (type == &PyList_Type || type == &PyTuple_Type)
    	return G_TYPE_STRV;

    return pyg_type_from_object (pytype);
}

static gchar *
_helper_wrap_get_string (PyObject *obj)
{
	PyObject *str;
	gchar *result;
	
	str = PyObject_Str (obj);
	
	if (!str)
		return NULL;
	
	result = g_strdup (PyString_AsString (str));
	Py_DECREF (str);
	
	return result;
}

static int
_helper_wrap_list_to_gvalue (GValue *gvalue, PyObject *pyvalue)
{
	int num;
	gchar **lst;
	gint i;
	
	num = PySequence_Size (pyvalue);
	lst = g_new0 (gchar *, num + 1);
	
	for (i = 0; i < num; i++)
	{
		lst[i] = _helper_wrap_get_string (PySequence_GetItem (pyvalue, i));
		
		if (lst[i] == NULL)
		{
			g_strfreev (lst);
			return 1;
		}
	}
	
	g_value_set_boxed (gvalue, lst);
	g_strfreev (lst);
	
	return 0;
}

static int
_helper_wrap_get_gvalue_from_pyobject (GValue *gvalue, PyObject *pyvalue)
{
	if (pyvalue->ob_type == &PyList_Type || pyvalue->ob_type == &PyTuple_Type)
		return _helper_wrap_list_to_gvalue (gvalue, pyvalue);

	return pyg_value_from_pyobject(gvalue, pyvalue);
}

static int
_helper_wrap_message_set_value(GeditMessage *message, PyObject *pykey, PyObject *pyvalue)
{
    gchar *key;
    GType gtype;
    GValue value = {0,};

    key = _helper_wrap_get_string(pykey);
    
    if (key == NULL)
        return 0;

    gtype = gedit_message_get_key_type(message, key);
    
    if (gtype == 0) {
        PyErr_SetString(PyExc_TypeError, "invalid key");
        g_free (key);
        return 0;
    }

    g_value_init(&value, gtype);
    
    if (_helper_wrap_get_gvalue_from_pyobject (&value, pyvalue)) {
        PyErr_SetString(PyExc_TypeError,
                        "value is of the wrong type for this key");
        g_free (key);
        return 0;
    }

    gedit_message_set_value(message, key, &value);
    g_value_unset(&value);
    g_free (key);
    
    return 1;
}

typedef void (*ParsePairFunc)(PyObject *key, PyObject *value, gpointer user_data);

static void
_helper_parse_pairs_dict (PyObject *dict, ParsePairFunc func, gpointer user_data)
{
    if (!dict)
        return;
    
    PyObject *key, *value;
    Py_ssize_t i = 0;
    
    while (PyDict_Next(dict, &i, &key, &value))
    {
        func(key, value, user_data);
    }
}

static void
_helper_parse_pairs(PyObject *args, PyObject *kwargs, ParsePairFunc func, gpointer user_data)
{
    guint len;
    guint i;
    
    len = PyTuple_Size(args);
    
    for (i = 0; i < len; ++i)
    {
    	PyObject *d = PyTuple_GetItem(args, i);
    	
    	if (PyDict_Check(d))
            _helper_parse_pairs_dict(d, func, user_data);
    }
  
    _helper_parse_pairs_dict(kwargs, func, user_data);  
}

static void
_helper_message_set(PyObject *key, PyObject *value, GeditMessage *message)
{
    _helper_wrap_message_set_value(message, key, value);
}

static void
_helper_message_set_values(GeditMessage *message, PyObject *args, PyObject *kwargs)
{
    _helper_parse_pairs(args, kwargs, (ParsePairFunc)_helper_message_set, message);
}

static GeditMessage *
_helper_wrap_create_message(GeditMessageBus *bus, PyObject *args, PyObject *kwargs)
{
    PyObject *pypath, *pymethod, *pydict;
    
    if (!PyArg_ParseTuple(args, "OO|O:GeditMessage.create", &pypath, &pymethod, &pydict))
        return NULL;
    
    gchar *object_path = _helper_wrap_get_string(pypath);
    gchar *method = _helper_wrap_get_string(pymethod);
    
    GeditMessageType *message_type = gedit_message_bus_lookup (bus, object_path, method);
    GeditMessage *message;
     
    if (message_type)
    {
        message = gedit_message_type_instantiate(message_type, NULL);
        _helper_message_set_values(message, args, kwargs);
    }
    else
    {
    	PyErr_SetString(PyExc_StandardError, "Message type does not exist");
        message = NULL;
    }
    
    g_free(object_path);
    g_free(method);
    
    return message;
}

typedef struct {
    PyObject *func;
    PyObject *data;
} PyGeditCustomNotify;

static void 
pygedit_custom_destroy_notify(gpointer user_data)
{
    PyGeditCustomNotify *cunote = user_data;
    PyGILState_STATE state;
    
    g_return_if_fail(user_data);
    state = pyg_gil_state_ensure();
    Py_XDECREF(cunote->func);
    Py_XDECREF(cunote->data);
    pyg_gil_state_release(state);
    
    g_free(cunote);
}
#line 277 "gedit.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGtkWidget_Type;
#define PyGtkWidget_Type (*_PyGtkWidget_Type)
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)
static PyTypeObject *_PyGdkScreen_Type;
#define PyGdkScreen_Type (*_PyGdkScreen_Type)
static PyTypeObject *_PyGtkVBox_Type;
#define PyGtkVBox_Type (*_PyGtkVBox_Type)
static PyTypeObject *_PyGtkWindow_Type;
#define PyGtkWindow_Type (*_PyGtkWindow_Type)
static PyTypeObject *_PyGtkImage_Type;
#define PyGtkImage_Type (*_PyGtkImage_Type)
static PyTypeObject *_PyGtkStatusbar_Type;
#define PyGtkStatusbar_Type (*_PyGtkStatusbar_Type)
static PyTypeObject *_PyGtkSourceBuffer_Type;
#define PyGtkSourceBuffer_Type (*_PyGtkSourceBuffer_Type)
static PyTypeObject *_PyGtkSourceView_Type;
#define PyGtkSourceView_Type (*_PyGtkSourceView_Type)
static PyTypeObject *_PyGtkSourceLanguage_Type;
#define PyGtkSourceLanguage_Type (*_PyGtkSourceLanguage_Type)
static PyTypeObject *_PyGtkSourceLanguageManager_Type;
#define PyGtkSourceLanguageManager_Type (*_PyGtkSourceLanguageManager_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject G_GNUC_INTERNAL PyGeditEncoding_Type;
PyTypeObject G_GNUC_INTERNAL PyGeditMessageType_Type;
PyTypeObject G_GNUC_INTERNAL PyGeditApp_Type;
PyTypeObject G_GNUC_INTERNAL PyGeditDocument_Type;
PyTypeObject G_GNUC_INTERNAL PyGeditMessage_Type;
PyTypeObject G_GNUC_INTERNAL PyGeditMessageBus_Type;
PyTypeObject G_GNUC_INTERNAL PyGeditPanel_Type;
PyTypeObject G_GNUC_INTERNAL PyGeditPlugin_Type;
PyTypeObject G_GNUC_INTERNAL PyGeditPluginPython_Type;
PyTypeObject G_GNUC_INTERNAL PyGeditStatusbar_Type;
PyTypeObject G_GNUC_INTERNAL PyGeditTab_Type;
PyTypeObject G_GNUC_INTERNAL PyGeditView_Type;
PyTypeObject G_GNUC_INTERNAL PyGeditWindow_Type;

#line 320 "gedit.c"



/* ----------- GeditEncoding ----------- */

static int
pygobject_no_constructor(PyObject *self, PyObject *args, PyObject *kwargs)
{
    gchar buf[512];

    g_snprintf(buf, sizeof(buf), "%s is an abstract widget", self->ob_type->tp_name);
    PyErr_SetString(PyExc_NotImplementedError, buf);
    return -1;
}

static PyObject *
_wrap_gedit_encoding_copy(PyObject *self)
{
    GeditEncoding *ret;

    
    ret = gedit_encoding_copy(pyg_boxed_get(self, GeditEncoding));
    
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(GEDIT_TYPE_ENCODING, ret, TRUE, TRUE);
}

static PyObject *
_wrap_gedit_encoding_free(PyObject *self)
{
    
    gedit_encoding_free(pyg_boxed_get(self, GeditEncoding));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_encoding_to_string(PyObject *self)
{
    gchar *ret;

    
    ret = gedit_encoding_to_string(pyg_boxed_get(self, GeditEncoding));
    
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_encoding_get_name(PyObject *self)
{
    const gchar *ret;

    
    ret = gedit_encoding_get_name(pyg_boxed_get(self, GeditEncoding));
    
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_encoding_get_charset(PyObject *self)
{
    const gchar *ret;

    
    ret = gedit_encoding_get_charset(pyg_boxed_get(self, GeditEncoding));
    
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static const PyMethodDef _PyGeditEncoding_methods[] = {
    { "copy", (PyCFunction)_wrap_gedit_encoding_copy, METH_NOARGS,
      NULL },
    { "free", (PyCFunction)_wrap_gedit_encoding_free, METH_NOARGS,
      NULL },
    { "to_string", (PyCFunction)_wrap_gedit_encoding_to_string, METH_NOARGS,
      NULL },
    { "get_name", (PyCFunction)_wrap_gedit_encoding_get_name, METH_NOARGS,
      NULL },
    { "get_charset", (PyCFunction)_wrap_gedit_encoding_get_charset, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyGeditEncoding_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "gedit.Encoding",                   /* tp_name */
    sizeof(PyGBoxed),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    0,             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyGeditEncoding_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    0,                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- GeditMessageType ----------- */

#line 219 "geditmessage.override"

typedef struct
{
    GeditMessageType *message_type;
    PyObject *optional;
} MessageTypeSetInfo;

static void
_message_type_set(PyObject *key, PyObject *value, MessageTypeSetInfo *info)
{
    GType gtype;
    
    gchar *k = _helper_wrap_get_string(key);

    if (!k)
        return;

    gtype = _helper_wrap_get_gtype_from_pytype(value);
    
    gboolean optional = info->optional && PySequence_Contains(info->optional, key);
    
    gedit_message_type_set(info->message_type, optional, k, gtype, NULL);
    g_free(k);
}

static int
_wrap_gedit_message_type_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    PyObject *pypath, *pymethod, *optional = NULL, *pydict;
    
    if (!PyArg_ParseTuple(args, "OO|OO:GeditMessageType.new", &pypath, &pymethod, &optional, &pydict))
        return -1;
    
    GeditMessageType *message_type = GEDIT_MESSAGE_TYPE(g_object_new(pyg_type_from_object((PyObject *) self), NULL));
    
    MessageTypeSetInfo info = {message_type, optional && PySequence_Check(optional) ? optional : NULL};
    _helper_parse_pairs (args, kwargs, (ParsePairFunc)_message_type_set, &info);
    
    self->obj = (GObject *)message_type;    
    pygobject_register_wrapper((PyObject *) self);
    
    return 0;
}
#line 510 "gedit.c"


static PyObject *
_wrap_gedit_message_type_ref(PyObject *self)
{
    GeditMessageType *ret;

    
    ret = gedit_message_type_ref(pyg_boxed_get(self, GeditMessageType));
    
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(GEDIT_TYPE_MESSAGE_TYPE, ret, TRUE, TRUE);
}

static PyObject *
_wrap_gedit_message_type_unref(PyObject *self)
{
    
    gedit_message_type_unref(pyg_boxed_get(self, GeditMessageType));
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 264 "geditmessage.override"
static PyObject *
_wrap_gedit_message_type_instantiate(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    GeditMessageType *message_type = GEDIT_MESSAGE_TYPE (self->obj);
    GeditMessage *message = gedit_message_type_instantiate(message_type, NULL);
    
    _helper_message_set_values(message, args, kwargs);
    
    return pygobject_new((GObject *)message);
}
#line 546 "gedit.c"


static PyObject *
_wrap_gedit_message_type_get_object_path(PyObject *self)
{
    const gchar *ret;

    
    ret = gedit_message_type_get_object_path(pyg_boxed_get(self, GeditMessageType));
    
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_message_type_get_method(PyObject *self)
{
    const gchar *ret;

    
    ret = gedit_message_type_get_method(pyg_boxed_get(self, GeditMessageType));
    
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_message_type_lookup(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "key", NULL };
    char *key;
    GType ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:Gedit.MessageType.lookup", kwlist, &key))
        return NULL;
    
    ret = gedit_message_type_lookup(pyg_boxed_get(self, GeditMessageType), key);
    
    return pyg_type_wrapper_new(ret);
}

static const PyMethodDef _PyGeditMessageType_methods[] = {
    { "ref", (PyCFunction)_wrap_gedit_message_type_ref, METH_NOARGS,
      NULL },
    { "unref", (PyCFunction)_wrap_gedit_message_type_unref, METH_NOARGS,
      NULL },
    { "instantiate", (PyCFunction)_wrap_gedit_message_type_instantiate, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_object_path", (PyCFunction)_wrap_gedit_message_type_get_object_path, METH_NOARGS,
      NULL },
    { "get_method", (PyCFunction)_wrap_gedit_message_type_get_method, METH_NOARGS,
      NULL },
    { "lookup", (PyCFunction)_wrap_gedit_message_type_lookup, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyGeditMessageType_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "gedit.MessageType",                   /* tp_name */
    sizeof(PyGBoxed),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    0,             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyGeditMessageType_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    0,                 /* tp_dictoffset */
    (initproc)_wrap_gedit_message_type_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- GeditApp ----------- */

#line 88 "gedit.override"
static PyObject *
_wrap_gedit_app_create_window(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "screen", NULL};
    PyGObject *screen = NULL;
    GeditWindow *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
			"|O!", kwlist,
			&PyGdkScreen_Type, &screen))
        return NULL;

    ret = gedit_app_create_window(GEDIT_APP(self->obj),
				  screen ? GDK_SCREEN(screen->obj) : NULL);

    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}
#line 676 "gedit.c"


#line 108 "gedit.override"
static PyObject *
_wrap_gedit_app_get_windows(PyGObject *self)
{
    const GList *list;
    PyObject *py_list;

    list = gedit_app_get_windows (GEDIT_APP (self->obj));

    py_list = _helper_wrap_gobject_glist (list);

    return py_list;
}
#line 692 "gedit.c"


static PyObject *
_wrap_gedit_app_get_active_window(PyGObject *self)
{
    GeditWindow *ret;

    
    ret = gedit_app_get_active_window(GEDIT_APP(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

#line 138 "gedit.override"
static PyObject *
_wrap_gedit_app_get_documents(PyGObject *self)
{
    GList *list;
    PyObject *py_list;

    list = gedit_app_get_documents (GEDIT_APP (self->obj));

    py_list = _helper_wrap_gobject_glist (list);

    g_list_free (list);

    return py_list;
}
#line 722 "gedit.c"


#line 122 "gedit.override"
static PyObject *
_wrap_gedit_app_get_views(PyGObject *self)
{
    GList *list;
    PyObject *py_list;

    list = gedit_app_get_views (GEDIT_APP (self->obj));

    py_list = _helper_wrap_gobject_glist (list);

    g_list_free (list);

    return py_list;
}
#line 740 "gedit.c"


static PyObject *
_wrap_gedit_app_get_lockdown(PyGObject *self)
{
    guint ret;

    
    ret = gedit_app_get_lockdown(GEDIT_APP(self->obj));
    
    return pyg_flags_from_gtype(GEDIT_TYPE_LOCKDOWN_MASK, ret);
}

static const PyMethodDef _PyGeditApp_methods[] = {
    { "create_window", (PyCFunction)_wrap_gedit_app_create_window, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_windows", (PyCFunction)_wrap_gedit_app_get_windows, METH_VARARGS,
      NULL },
    { "get_active_window", (PyCFunction)_wrap_gedit_app_get_active_window, METH_NOARGS,
      NULL },
    { "get_documents", (PyCFunction)_wrap_gedit_app_get_documents, METH_VARARGS,
      NULL },
    { "get_views", (PyCFunction)_wrap_gedit_app_get_views, METH_VARARGS,
      NULL },
    { "get_lockdown", (PyCFunction)_wrap_gedit_app_get_lockdown, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyGeditApp_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "gedit.App",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyGeditApp_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)0,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- GeditDocument ----------- */

static int
_wrap_gedit_document_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char* kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                     ":gedit.Document.__init__",
                                     kwlist))
        return -1;

    pygobject_constructv(self, 0, NULL);
    if (!self->obj) {
        PyErr_SetString(
            PyExc_RuntimeError, 
            "could not create gedit.Document object");
        return -1;
    }
    return 0;
}

static PyObject *
_wrap_gedit_document_get_uri(PyGObject *self)
{
    gchar *ret;

    
    ret = gedit_document_get_uri(GEDIT_DOCUMENT(self->obj));
    
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_document_set_uri(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "uri", NULL };
    char *uri;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:Gedit.Document.set_uri", kwlist, &uri))
        return NULL;
    
    gedit_document_set_uri(GEDIT_DOCUMENT(self->obj), uri);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_document_get_uri_for_display(PyGObject *self)
{
    gchar *ret;

    
    ret = gedit_document_get_uri_for_display(GEDIT_DOCUMENT(self->obj));
    
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_document_get_short_name_for_display(PyGObject *self)
{
    gchar *ret;

    
    ret = gedit_document_get_short_name_for_display(GEDIT_DOCUMENT(self->obj));
    
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_document_get_content_type(PyGObject *self)
{
    gchar *ret;

    
    ret = gedit_document_get_content_type(GEDIT_DOCUMENT(self->obj));
    
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_document_get_mime_type(PyGObject *self)
{
    gchar *ret;

    
    ret = gedit_document_get_mime_type(GEDIT_DOCUMENT(self->obj));
    
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_document_get_readonly(PyGObject *self)
{
    int ret;

    
    ret = gedit_document_get_readonly(GEDIT_DOCUMENT(self->obj));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_document_load(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "uri", "encoding", "line_pos", "create", NULL };
    char *uri;
    GeditEncoding *encoding = NULL;
    int line_pos, create;
    PyObject *py_encoding;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"sOii:Gedit.Document.load", kwlist, &uri, &py_encoding, &line_pos, &create))
        return NULL;
    if (pyg_boxed_check(py_encoding, GEDIT_TYPE_ENCODING))
        encoding = pyg_boxed_get(py_encoding, GeditEncoding);
    else {
        PyErr_SetString(PyExc_TypeError, "encoding should be a GeditEncoding");
        return NULL;
    }
    
    gedit_document_load(GEDIT_DOCUMENT(self->obj), uri, encoding, line_pos, create);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_document_insert_file(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "iter", "uri", "encoding", NULL };
    PyObject *py_iter, *py_encoding;
    char *uri;
    int ret;
    GtkTextIter *iter = NULL;
    GeditEncoding *encoding = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"OsO:Gedit.Document.insert_file", kwlist, &py_iter, &uri, &py_encoding))
        return NULL;
    if (pyg_boxed_check(py_iter, GTK_TYPE_TEXT_ITER))
        iter = pyg_boxed_get(py_iter, GtkTextIter);
    else {
        PyErr_SetString(PyExc_TypeError, "iter should be a GtkTextIter");
        return NULL;
    }
    if (pyg_boxed_check(py_encoding, GEDIT_TYPE_ENCODING))
        encoding = pyg_boxed_get(py_encoding, GeditEncoding);
    else {
        PyErr_SetString(PyExc_TypeError, "encoding should be a GeditEncoding");
        return NULL;
    }
    
    ret = gedit_document_insert_file(GEDIT_DOCUMENT(self->obj), iter, uri, encoding);
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_document_load_cancel(PyGObject *self)
{
    int ret;

    
    ret = gedit_document_load_cancel(GEDIT_DOCUMENT(self->obj));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_document_save(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "flags", NULL };
    PyObject *py_flags = NULL;
    GeditDocumentSaveFlags flags;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:Gedit.Document.save", kwlist, &py_flags))
        return NULL;
    if (pyg_flags_get_value(GEDIT_TYPE_DOCUMENT_SAVE_FLAGS, py_flags, (gpointer)&flags))
        return NULL;
    
    gedit_document_save(GEDIT_DOCUMENT(self->obj), flags);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_document_save_as(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "uri", "encoding", "flags", NULL };
    char *uri;
    GeditEncoding *encoding = NULL;
    GeditDocumentSaveFlags flags;
    PyObject *py_encoding, *py_flags = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"sOO:Gedit.Document.save_as", kwlist, &uri, &py_encoding, &py_flags))
        return NULL;
    if (pyg_boxed_check(py_encoding, GEDIT_TYPE_ENCODING))
        encoding = pyg_boxed_get(py_encoding, GeditEncoding);
    else {
        PyErr_SetString(PyExc_TypeError, "encoding should be a GeditEncoding");
        return NULL;
    }
    if (pyg_flags_get_value(GEDIT_TYPE_DOCUMENT_SAVE_FLAGS, py_flags, (gpointer)&flags))
        return NULL;
    
    gedit_document_save_as(GEDIT_DOCUMENT(self->obj), uri, encoding, flags);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_document_is_untouched(PyGObject *self)
{
    int ret;

    
    ret = gedit_document_is_untouched(GEDIT_DOCUMENT(self->obj));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_document_is_untitled(PyGObject *self)
{
    int ret;

    
    ret = gedit_document_is_untitled(GEDIT_DOCUMENT(self->obj));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_document_is_local(PyGObject *self)
{
    int ret;

    
    ret = gedit_document_is_local(GEDIT_DOCUMENT(self->obj));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_document_get_deleted(PyGObject *self)
{
    int ret;

    
    ret = gedit_document_get_deleted(GEDIT_DOCUMENT(self->obj));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_document_goto_line(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "line", NULL };
    int line, ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:Gedit.Document.goto_line", kwlist, &line))
        return NULL;
    
    ret = gedit_document_goto_line(GEDIT_DOCUMENT(self->obj), line);
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_document_set_search_text(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "text", "flags", NULL };
    char *text;
    PyObject *py_flags = NULL;
    guint flags = 0;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"sO:Gedit.Document.set_search_text", kwlist, &text, &py_flags))
        return NULL;
    if (py_flags) {
        if (PyLong_Check(py_flags))
            flags = PyLong_AsUnsignedLong(py_flags);
        else if (PyInt_Check(py_flags))
            flags = PyInt_AsLong(py_flags);
        else
            PyErr_SetString(PyExc_TypeError, "Parameter 'flags' must be an int or a long");
        if (PyErr_Occurred())
            return NULL;
    }
    
    gedit_document_set_search_text(GEDIT_DOCUMENT(self->obj), text, flags);
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 250 "gedit.override"
static PyObject *
_wrap_gedit_document_get_search_text(PyGObject *self)
{
    PyObject *tuple, *string;
    guint flags;
    gchar *ret;

    ret = gedit_document_get_search_text (GEDIT_DOCUMENT (self->obj), &flags);

    tuple = PyTuple_New(2);
    if (ret) {
        string = PyString_FromString(ret);
        PyTuple_SetItem(tuple, 0, string);
    } else {
        Py_INCREF(Py_None);
        PyTuple_SetItem(tuple, 0, Py_None);
    }
    PyTuple_SetItem(tuple, 1, PyInt_FromLong(flags));

    g_free(ret);

    return tuple;
}
#line 1176 "gedit.c"


static PyObject *
_wrap_gedit_document_get_can_search_again(PyGObject *self)
{
    int ret;

    
    ret = gedit_document_get_can_search_again(GEDIT_DOCUMENT(self->obj));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_document_search_forward(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "start", "end", "match_start", "match_end", NULL };
    PyObject *py_start, *py_end, *py_match_start, *py_match_end;
    int ret;
    GtkTextIter *start = NULL, *end = NULL, *match_start = NULL, *match_end = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"OOOO:Gedit.Document.search_forward", kwlist, &py_start, &py_end, &py_match_start, &py_match_end))
        return NULL;
    if (pyg_boxed_check(py_start, GTK_TYPE_TEXT_ITER))
        start = pyg_boxed_get(py_start, GtkTextIter);
    else {
        PyErr_SetString(PyExc_TypeError, "start should be a GtkTextIter");
        return NULL;
    }
    if (pyg_boxed_check(py_end, GTK_TYPE_TEXT_ITER))
        end = pyg_boxed_get(py_end, GtkTextIter);
    else {
        PyErr_SetString(PyExc_TypeError, "end should be a GtkTextIter");
        return NULL;
    }
    if (pyg_boxed_check(py_match_start, GTK_TYPE_TEXT_ITER))
        match_start = pyg_boxed_get(py_match_start, GtkTextIter);
    else {
        PyErr_SetString(PyExc_TypeError, "match_start should be a GtkTextIter");
        return NULL;
    }
    if (pyg_boxed_check(py_match_end, GTK_TYPE_TEXT_ITER))
        match_end = pyg_boxed_get(py_match_end, GtkTextIter);
    else {
        PyErr_SetString(PyExc_TypeError, "match_end should be a GtkTextIter");
        return NULL;
    }
    
    ret = gedit_document_search_forward(GEDIT_DOCUMENT(self->obj), start, end, match_start, match_end);
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_document_replace_all(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "find", "replace", "flags", NULL };
    char *find, *replace;
    PyObject *py_flags = NULL;
    int ret;
    guint flags = 0;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ssO:Gedit.Document.replace_all", kwlist, &find, &replace, &py_flags))
        return NULL;
    if (py_flags) {
        if (PyLong_Check(py_flags))
            flags = PyLong_AsUnsignedLong(py_flags);
        else if (PyInt_Check(py_flags))
            flags = PyInt_AsLong(py_flags);
        else
            PyErr_SetString(PyExc_TypeError, "Parameter 'flags' must be an int or a long");
        if (PyErr_Occurred())
            return NULL;
    }
    
    ret = gedit_document_replace_all(GEDIT_DOCUMENT(self->obj), find, replace, flags);
    
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gedit_document_search_backward(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "start", "end", "match_start", "match_end", NULL };
    PyObject *py_start, *py_end, *py_match_start, *py_match_end;
    int ret;
    GtkTextIter *start = NULL, *end = NULL, *match_start = NULL, *match_end = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"OOOO:Gedit.Document.search_backward", kwlist, &py_start, &py_end, &py_match_start, &py_match_end))
        return NULL;
    if (pyg_boxed_check(py_start, GTK_TYPE_TEXT_ITER))
        start = pyg_boxed_get(py_start, GtkTextIter);
    else {
        PyErr_SetString(PyExc_TypeError, "start should be a GtkTextIter");
        return NULL;
    }
    if (pyg_boxed_check(py_end, GTK_TYPE_TEXT_ITER))
        end = pyg_boxed_get(py_end, GtkTextIter);
    else {
        PyErr_SetString(PyExc_TypeError, "end should be a GtkTextIter");
        return NULL;
    }
    if (pyg_boxed_check(py_match_start, GTK_TYPE_TEXT_ITER))
        match_start = pyg_boxed_get(py_match_start, GtkTextIter);
    else {
        PyErr_SetString(PyExc_TypeError, "match_start should be a GtkTextIter");
        return NULL;
    }
    if (pyg_boxed_check(py_match_end, GTK_TYPE_TEXT_ITER))
        match_end = pyg_boxed_get(py_match_end, GtkTextIter);
    else {
        PyErr_SetString(PyExc_TypeError, "match_end should be a GtkTextIter");
        return NULL;
    }
    
    ret = gedit_document_search_backward(GEDIT_DOCUMENT(self->obj), start, end, match_start, match_end);
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_document_set_language(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "lang", NULL };
    GtkSourceLanguage *lang = NULL;
    PyGObject *py_lang;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:Gedit.Document.set_language", kwlist, &py_lang))
        return NULL;
    if (py_lang && pygobject_check(py_lang, &PyGtkSourceLanguage_Type))
        lang = GTK_SOURCE_LANGUAGE(py_lang->obj);
    else if ((PyObject *)py_lang != Py_None) {
        PyErr_SetString(PyExc_TypeError, "lang should be a GtkSourceLanguage or None");
        return NULL;
    }
    
    gedit_document_set_language(GEDIT_DOCUMENT(self->obj), (GtkSourceLanguage *) lang);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_document_get_language(PyGObject *self)
{
    GtkSourceLanguage *ret;

    
    ret = gedit_document_get_language(GEDIT_DOCUMENT(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_document_get_encoding(PyGObject *self)
{
    const GeditEncoding *ret;

    
    ret = gedit_document_get_encoding(GEDIT_DOCUMENT(self->obj));
    
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(GEDIT_TYPE_ENCODING, (GeditEncoding*) ret, TRUE, TRUE);
}

static PyObject *
_wrap_gedit_document_set_enable_search_highlighting(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "enable", NULL };
    int enable;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:Gedit.Document.set_enable_search_highlighting", kwlist, &enable))
        return NULL;
    
    gedit_document_set_enable_search_highlighting(GEDIT_DOCUMENT(self->obj), enable);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_document_get_enable_search_highlighting(PyGObject *self)
{
    int ret;

    
    ret = gedit_document_get_enable_search_highlighting(GEDIT_DOCUMENT(self->obj));
    
    return PyBool_FromLong(ret);

}

static const PyMethodDef _PyGeditDocument_methods[] = {
    { "get_uri", (PyCFunction)_wrap_gedit_document_get_uri, METH_NOARGS,
      NULL },
    { "set_uri", (PyCFunction)_wrap_gedit_document_set_uri, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_uri_for_display", (PyCFunction)_wrap_gedit_document_get_uri_for_display, METH_NOARGS,
      NULL },
    { "get_short_name_for_display", (PyCFunction)_wrap_gedit_document_get_short_name_for_display, METH_NOARGS,
      NULL },
    { "get_content_type", (PyCFunction)_wrap_gedit_document_get_content_type, METH_NOARGS,
      NULL },
    { "get_mime_type", (PyCFunction)_wrap_gedit_document_get_mime_type, METH_NOARGS,
      NULL },
    { "get_readonly", (PyCFunction)_wrap_gedit_document_get_readonly, METH_NOARGS,
      NULL },
    { "load", (PyCFunction)_wrap_gedit_document_load, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "insert_file", (PyCFunction)_wrap_gedit_document_insert_file, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "load_cancel", (PyCFunction)_wrap_gedit_document_load_cancel, METH_NOARGS,
      NULL },
    { "save", (PyCFunction)_wrap_gedit_document_save, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "save_as", (PyCFunction)_wrap_gedit_document_save_as, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "is_untouched", (PyCFunction)_wrap_gedit_document_is_untouched, METH_NOARGS,
      NULL },
    { "is_untitled", (PyCFunction)_wrap_gedit_document_is_untitled, METH_NOARGS,
      NULL },
    { "is_local", (PyCFunction)_wrap_gedit_document_is_local, METH_NOARGS,
      NULL },
    { "get_deleted", (PyCFunction)_wrap_gedit_document_get_deleted, METH_NOARGS,
      NULL },
    { "goto_line", (PyCFunction)_wrap_gedit_document_goto_line, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "set_search_text", (PyCFunction)_wrap_gedit_document_set_search_text, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_search_text", (PyCFunction)_wrap_gedit_document_get_search_text, METH_VARARGS,
      NULL },
    { "get_can_search_again", (PyCFunction)_wrap_gedit_document_get_can_search_again, METH_NOARGS,
      NULL },
    { "search_forward", (PyCFunction)_wrap_gedit_document_search_forward, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "replace_all", (PyCFunction)_wrap_gedit_document_replace_all, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "search_backward", (PyCFunction)_wrap_gedit_document_search_backward, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "set_language", (PyCFunction)_wrap_gedit_document_set_language, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_language", (PyCFunction)_wrap_gedit_document_get_language, METH_NOARGS,
      NULL },
    { "get_encoding", (PyCFunction)_wrap_gedit_document_get_encoding, METH_NOARGS,
      NULL },
    { "set_enable_search_highlighting", (PyCFunction)_wrap_gedit_document_set_enable_search_highlighting, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_enable_search_highlighting", (PyCFunction)_wrap_gedit_document_get_enable_search_highlighting, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyGeditDocument_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "gedit.Document",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyGeditDocument_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gedit_document_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- GeditMessage ----------- */

#line 276 "geditmessage.override"
static PyObject *
_wrap_gedit_message_get(PyGObject *self, PyObject *args)
{
    guint len, i;
    PyObject *ret;

    len = PyTuple_Size(args);
    
    ret = PyTuple_New(len);
    
    for (i = 0; i < len; i++) {
        GValue value = { 0, };
        PyObject *py_key = PyTuple_GetItem(args, i);
        gchar *key = _helper_wrap_get_string(py_key);
        
        if (!key) {
	    PyErr_SetString(PyExc_TypeError, "keys must be strings");
	    Py_DECREF(ret);
	    return NULL;
	}
	
	gedit_message_get_value (GEDIT_MESSAGE (self->obj), key, &value);
	g_free (key);

	PyTuple_SetItem(ret, i, pyg_value_as_pyobject(&value, TRUE));
	g_value_unset(&value);
    }
    
    return ret;
}
#line 1513 "gedit.c"


#line 308 "geditmessage.override"
static PyObject *
_wrap_gedit_message_get_value(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "key", NULL };
    const gchar *key;
    PyObject *ret;
    GValue value = { 0, };
    
    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GeditMessage.get_value", kwlist, &key))
        return NULL;

    gedit_message_get_value(GEDIT_MESSAGE(self->obj), key, &value);
    ret = pyg_value_as_pyobject(&value, TRUE);
    g_value_unset(&value);
    
    return ret;
}
#line 1534 "gedit.c"


#line 344 "geditmessage.override"
static PyObject *
_wrap_gedit_message_set (PyGObject *self, PyObject *args, PyObject *kwargs) {
    _helper_message_set_values(GEDIT_MESSAGE(self->obj), args, kwargs);

    Py_INCREF(Py_None);
    return Py_None;
}
#line 1545 "gedit.c"


#line 327 "geditmessage.override"
static PyObject *
_wrap_gedit_message_set_value(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "key", "value", NULL };
    PyObject *pykey, *pyvalue;
    
    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "OO:GeditMessage.set_value", kwlist, &pykey, &pyvalue))
        return NULL;
    
    if (!_helper_wrap_message_set_value(GEDIT_MESSAGE(self->obj), pykey, pyvalue))
        return NULL;
    
    Py_INCREF(Py_None);
    return Py_None;
}
#line 1564 "gedit.c"


static PyObject *
_wrap_gedit_message_get_object_path(PyGObject *self)
{
    const gchar *ret;

    
    ret = gedit_message_get_object_path(GEDIT_MESSAGE(self->obj));
    
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_message_get_method(PyGObject *self)
{
    const gchar *ret;

    
    ret = gedit_message_get_method(GEDIT_MESSAGE(self->obj));
    
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_message_has_key(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "key", NULL };
    char *key;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:Gedit.Message.has_key", kwlist, &key))
        return NULL;
    
    ret = gedit_message_has_key(GEDIT_MESSAGE(self->obj), key);
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_message_get_key_type(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "key", NULL };
    char *key;
    GType ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:Gedit.Message.get_key_type", kwlist, &key))
        return NULL;
    
    ret = gedit_message_get_key_type(GEDIT_MESSAGE(self->obj), key);
    
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gedit_message_validate(PyGObject *self)
{
    int ret;

    
    ret = gedit_message_validate(GEDIT_MESSAGE(self->obj));
    
    return PyBool_FromLong(ret);

}

static const PyMethodDef _PyGeditMessage_methods[] = {
    { "get", (PyCFunction)_wrap_gedit_message_get, METH_VARARGS,
      NULL },
    { "get_value", (PyCFunction)_wrap_gedit_message_get_value, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "set", (PyCFunction)_wrap_gedit_message_set, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "set_value", (PyCFunction)_wrap_gedit_message_set_value, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_object_path", (PyCFunction)_wrap_gedit_message_get_object_path, METH_NOARGS,
      NULL },
    { "get_method", (PyCFunction)_wrap_gedit_message_get_method, METH_NOARGS,
      NULL },
    { "has_key", (PyCFunction)_wrap_gedit_message_has_key, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_key_type", (PyCFunction)_wrap_gedit_message_get_key_type, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "validate", (PyCFunction)_wrap_gedit_message_validate, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

#line 498 "geditmessage.override"
static PyObject *
_wrap_gedit_message_tp_getattro(PyObject *self, PyObject *attrname)
{
	GeditMessage *message = GEDIT_MESSAGE(((PyGObject *)self)->obj);
	GeditMessageType *type;

	gchar *name = _helper_wrap_get_string (attrname);
	gboolean exists;
	gboolean intype;
	PyObject *ret;
	
	if (name == NULL)
	{
		PyErr_SetString(PyExc_TypeError, "attr name somehow not a string");
		return NULL;
	}
	
	g_object_get (message, "type", &type, NULL);
	intype = gedit_message_type_lookup (type, name) != G_TYPE_INVALID;
	gedit_message_type_unref (type);
	
	exists = gedit_message_has_key (message, name);
	
	if (!intype)
	{
		ret = PyObject_GenericGetAttr(self, attrname);
	}
	else if (exists)
	{
		GValue value = { 0, };
		gedit_message_get_value (message, name, &value);
		ret = pyg_value_as_pyobject(&value, TRUE);
		g_value_unset (&value);
	}
	else
	{
		Py_INCREF(Py_None);
		ret = Py_None;
	}

	g_free (name);
	return ret;
}
#line 1704 "gedit.c"


#line 543 "geditmessage.override"
static int
_wrap_gedit_message_tp_setattro(PyObject *self, PyObject *attrname, PyObject *value)
{
	GeditMessage *message = GEDIT_MESSAGE(((PyGObject *)self)->obj);

	if (!_helper_wrap_message_set_value(message, attrname, value))
	{
		return PyObject_GenericSetAttr(self, attrname, value);
	}
	else
	{
		return 1;
	}
}
#line 1722 "gedit.c"


PyTypeObject G_GNUC_INTERNAL PyGeditMessage_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "gedit.Message",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)_wrap_gedit_message_tp_getattro,     /* tp_getattro */
    (setattrofunc)_wrap_gedit_message_tp_setattro,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyGeditMessage_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)0,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- GeditMessageBus ----------- */

#line 353 "geditmessage.override"
static int
_wrap_gedit_message_bus_new(PyGObject *self)
{
    pygobject_construct (self, NULL);
    
    if (!self->obj) {
        PyErr_SetString (PyExc_RuntimeError, "could not create gedit.MessageBus object");
        return -1;
    }

    return 0;
}
#line 1787 "gedit.c"


static PyObject *
_wrap_gedit_message_bus_lookup(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "object_path", "method", NULL };
    char *object_path, *method;
    GeditMessageType *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ss:Gedit.MessageBus.lookup", kwlist, &object_path, &method))
        return NULL;
    
    ret = gedit_message_bus_lookup(GEDIT_MESSAGE_BUS(self->obj), object_path, method);
    
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(GEDIT_TYPE_MESSAGE_TYPE, ret, TRUE, TRUE);
}

#line 369 "geditmessage.override"
static PyObject *
_wrap_gedit_message_bus_register(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    PyObject *pypath, *pymethod, *optional = NULL, *pydict;
    GeditMessageBus *bus = GEDIT_MESSAGE_BUS(self->obj);

    if (!PyArg_ParseTuple(args, "OO|OO:GeditMessageBus.register", &pypath, &pymethod, &optional, &pydict))
        return NULL;
    
    gchar *object_path = _helper_wrap_get_string(pypath);
    gchar *method = _helper_wrap_get_string(pymethod);
    
    GeditMessageType *message_type = gedit_message_bus_register(bus, object_path, method, 0, NULL);
    
    g_free(object_path);
    g_free(method);
    
    if (!message_type)
    {
    	PyErr_SetString(PyExc_StandardError, "Message type already exists");
    	return NULL;
    }
    
    MessageTypeSetInfo info = {message_type, optional && PySequence_Check(optional) ? optional : NULL};
    _helper_parse_pairs (args, kwargs, (ParsePairFunc)_message_type_set, &info);
    
    return pyg_boxed_new(GEDIT_TYPE_MESSAGE_TYPE, message_type, TRUE, TRUE);
}
#line 1835 "gedit.c"


static PyObject *
_wrap_gedit_message_bus_unregister(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "message_type", NULL };
    GeditMessageType *message_type = NULL;
    PyObject *py_message_type;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:Gedit.MessageBus.unregister", kwlist, &py_message_type))
        return NULL;
    if (pyg_boxed_check(py_message_type, GEDIT_TYPE_MESSAGE_TYPE))
        message_type = pyg_boxed_get(py_message_type, GeditMessageType);
    else {
        PyErr_SetString(PyExc_TypeError, "message_type should be a GeditMessageType");
        return NULL;
    }
    
    gedit_message_bus_unregister(GEDIT_MESSAGE_BUS(self->obj), message_type);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_message_bus_unregister_all(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "object_path", NULL };
    char *object_path;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:Gedit.MessageBus.unregister_all", kwlist, &object_path))
        return NULL;
    
    gedit_message_bus_unregister_all(GEDIT_MESSAGE_BUS(self->obj), object_path);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_message_bus_is_registered(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "object_path", "method", NULL };
    char *object_path, *method;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ss:Gedit.MessageBus.is_registered", kwlist, &object_path, &method))
        return NULL;
    
    ret = gedit_message_bus_is_registered(GEDIT_MESSAGE_BUS(self->obj), object_path, method);
    
    return PyBool_FromLong(ret);

}

#line 399 "geditmessage.override"
static void
pygedit_message_bus_connect_cb(GeditMessageBus *bus, GeditMessage *message, gpointer data)
{
    PyGILState_STATE state;
    PyGeditCustomNotify *cunote = data;
    PyObject *pybus, *pymessage, *retobj;

    g_assert(cunote->func);

    state = pyg_gil_state_ensure();

    pybus = pygobject_new((GObject *)bus);
    pymessage = pygobject_new((GObject *)message);

    if (cunote->data) {
        retobj = PyEval_CallFunction(cunote->func, "(NNO)", pybus, pymessage, cunote->data);
    } else {
        retobj = PyEval_CallFunction(cunote->func, "(NN)", pybus, pymessage);
    }

    if (PyErr_Occurred()) {
        PyErr_Print();
    }

    Py_XDECREF(retobj);

    pyg_gil_state_release(state);
}

static PyObject *
_wrap_gedit_message_bus_connect(PyGObject *self, PyObject *args, PyObject *kwargs) 
{
    static char *kwlist[] = { "domain", "name", "func", "data", NULL };
    PyObject *pyfunc, *pyarg = NULL;
    const gchar *domain;
    const gchar *name;
    PyGeditCustomNotify *cunote;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "ssO|O:GeditMessageBus.connect",
				     kwlist, &domain, &name, &pyfunc, &pyarg))
        return NULL;

    if (!PyCallable_Check(pyfunc)) {
        PyErr_SetString(PyExc_TypeError, "func must be a callable object");
        return NULL;
    }
    cunote = g_new(PyGeditCustomNotify, 1);
    Py_INCREF(pyfunc);
    cunote->func = pyfunc;
    Py_XINCREF(pyarg);
    cunote->data = pyarg;

    guint id = gedit_message_bus_connect(GEDIT_MESSAGE_BUS(self->obj),
                                         domain,
                                         name,
                                         pygedit_message_bus_connect_cb,
                                         (gpointer)cunote,
                                         pygedit_custom_destroy_notify);
    return PyLong_FromUnsignedLong(id);
}
#line 1953 "gedit.c"


static PyObject *
_wrap_gedit_message_bus_disconnect(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "id", NULL };
    PyObject *py_id = NULL;
    guint id = 0;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:Gedit.MessageBus.disconnect", kwlist, &py_id))
        return NULL;
    if (py_id) {
        if (PyLong_Check(py_id))
            id = PyLong_AsUnsignedLong(py_id);
        else if (PyInt_Check(py_id))
            id = PyInt_AsLong(py_id);
        else
            PyErr_SetString(PyExc_TypeError, "Parameter 'id' must be an int or a long");
        if (PyErr_Occurred())
            return NULL;
    }
    
    gedit_message_bus_disconnect(GEDIT_MESSAGE_BUS(self->obj), id);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_message_bus_block(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "id", NULL };
    PyObject *py_id = NULL;
    guint id = 0;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:Gedit.MessageBus.block", kwlist, &py_id))
        return NULL;
    if (py_id) {
        if (PyLong_Check(py_id))
            id = PyLong_AsUnsignedLong(py_id);
        else if (PyInt_Check(py_id))
            id = PyInt_AsLong(py_id);
        else
            PyErr_SetString(PyExc_TypeError, "Parameter 'id' must be an int or a long");
        if (PyErr_Occurred())
            return NULL;
    }
    
    gedit_message_bus_block(GEDIT_MESSAGE_BUS(self->obj), id);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_message_bus_unblock(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "id", NULL };
    PyObject *py_id = NULL;
    guint id = 0;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:Gedit.MessageBus.unblock", kwlist, &py_id))
        return NULL;
    if (py_id) {
        if (PyLong_Check(py_id))
            id = PyLong_AsUnsignedLong(py_id);
        else if (PyInt_Check(py_id))
            id = PyInt_AsLong(py_id);
        else
            PyErr_SetString(PyExc_TypeError, "Parameter 'id' must be an int or a long");
        if (PyErr_Occurred())
            return NULL;
    }
    
    gedit_message_bus_unblock(GEDIT_MESSAGE_BUS(self->obj), id);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_message_bus_send_message(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "message", NULL };
    PyGObject *message;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:Gedit.MessageBus.send_message", kwlist, &PyGeditMessage_Type, &message))
        return NULL;
    
    gedit_message_bus_send_message(GEDIT_MESSAGE_BUS(self->obj), GEDIT_MESSAGE(message->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_message_bus_send_message_sync(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "message", NULL };
    PyGObject *message;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:Gedit.MessageBus.send_message_sync", kwlist, &PyGeditMessage_Type, &message))
        return NULL;
    
    gedit_message_bus_send_message_sync(GEDIT_MESSAGE_BUS(self->obj), GEDIT_MESSAGE(message->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 462 "geditmessage.override"
static PyObject *
_wrap_gedit_message_bus_send(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    /* create a new message object */
    GeditMessage *message;
    GeditMessageBus *bus = GEDIT_MESSAGE_BUS(self->obj);
    message = _helper_wrap_create_message(bus, args, kwargs);
    
    if (!message)
        return NULL;
    
    gedit_message_bus_send_message(bus, message);
    g_object_unref (message);
    
    Py_INCREF(Py_None);
    return Py_None;
}
#line 2082 "gedit.c"


#line 481 "geditmessage.override"
static PyObject *
_wrap_gedit_message_bus_send_sync(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    /* create a new message object */
    GeditMessage *message;
    GeditMessageBus *bus = GEDIT_MESSAGE_BUS(self->obj);
    
    message = _helper_wrap_create_message(bus, args, kwargs);
    
    if (!message)
        return NULL;
    
    gedit_message_bus_send_message_sync(bus, message);
    return pygobject_new((GObject *)message);
}
#line 2101 "gedit.c"


static const PyMethodDef _PyGeditMessageBus_methods[] = {
    { "lookup", (PyCFunction)_wrap_gedit_message_bus_lookup, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "register", (PyCFunction)_wrap_gedit_message_bus_register, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "unregister", (PyCFunction)_wrap_gedit_message_bus_unregister, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "unregister_all", (PyCFunction)_wrap_gedit_message_bus_unregister_all, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "is_registered", (PyCFunction)_wrap_gedit_message_bus_is_registered, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "connect", (PyCFunction)_wrap_gedit_message_bus_connect, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "disconnect", (PyCFunction)_wrap_gedit_message_bus_disconnect, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "block", (PyCFunction)_wrap_gedit_message_bus_block, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "unblock", (PyCFunction)_wrap_gedit_message_bus_unblock, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "send_message", (PyCFunction)_wrap_gedit_message_bus_send_message, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "send_message_sync", (PyCFunction)_wrap_gedit_message_bus_send_message_sync, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "send", (PyCFunction)_wrap_gedit_message_bus_send, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "send_sync", (PyCFunction)_wrap_gedit_message_bus_send_sync, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyGeditMessageBus_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "gedit.MessageBus",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyGeditMessageBus_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gedit_message_bus_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- GeditPanel ----------- */

static int
_wrap_gedit_panel_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char* kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                     ":gedit.Panel.__init__",
                                     kwlist))
        return -1;

    pygobject_constructv(self, 0, NULL);
    if (!self->obj) {
        PyErr_SetString(
            PyExc_RuntimeError, 
            "could not create gedit.Panel object");
        return -1;
    }
    return 0;
}

#line 275 "gedit.override"
static PyObject *
_wrap_gedit_panel_add_item(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist1[] = { "item", "name", "image", NULL };
    static char *kwlist2[] = { "item", "name", "stock_id", NULL };
    PyGObject *item, *image;
    char *name = NULL;
    char *stock_id = NULL;

    if (PyArg_ParseTupleAndKeywords(args, kwargs, "O!sO!:GeditPanel.add_item", kwlist1, &PyGtkWidget_Type, &item, &name, &PyGtkImage_Type, &image)) {
        gedit_panel_add_item(GEDIT_PANEL(self->obj), GTK_WIDGET(item->obj), name, GTK_WIDGET(image->obj));
        Py_INCREF(Py_None);
        return Py_None;
    }

    PyErr_Clear();

    if (PyArg_ParseTupleAndKeywords(args, kwargs, "O!ss:GeditPanel.add_item", kwlist2, &PyGtkWidget_Type, &item, &name, &stock_id)) {
        gedit_panel_add_item_with_stock_icon(GEDIT_PANEL(self->obj), GTK_WIDGET(item->obj), name, stock_id);
        Py_INCREF(Py_None);
        return Py_None;
    }

    PyErr_Clear();
    PyErr_SetString(PyExc_TypeError, "the last arg should be either a gtk.Image or a stock_id string");
    return NULL;
}
#line 2231 "gedit.c"


static PyObject *
_wrap_gedit_panel_remove_item(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "item", NULL };
    PyGObject *item;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:Gedit.Panel.remove_item", kwlist, &PyGtkWidget_Type, &item))
        return NULL;
    
    ret = gedit_panel_remove_item(GEDIT_PANEL(self->obj), GTK_WIDGET(item->obj));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_panel_activate_item(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "item", NULL };
    PyGObject *item;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:Gedit.Panel.activate_item", kwlist, &PyGtkWidget_Type, &item))
        return NULL;
    
    ret = gedit_panel_activate_item(GEDIT_PANEL(self->obj), GTK_WIDGET(item->obj));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_panel_item_is_active(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "item", NULL };
    PyGObject *item;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:Gedit.Panel.item_is_active", kwlist, &PyGtkWidget_Type, &item))
        return NULL;
    
    ret = gedit_panel_item_is_active(GEDIT_PANEL(self->obj), GTK_WIDGET(item->obj));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_panel_get_orientation(PyGObject *self)
{
    gint ret;

    
    ret = gedit_panel_get_orientation(GEDIT_PANEL(self->obj));
    
    return pyg_enum_from_gtype(GTK_TYPE_ORIENTATION, ret);
}

static PyObject *
_wrap_gedit_panel_get_n_items(PyGObject *self)
{
    int ret;

    
    ret = gedit_panel_get_n_items(GEDIT_PANEL(self->obj));
    
    return PyInt_FromLong(ret);
}

static const PyMethodDef _PyGeditPanel_methods[] = {
    { "add_item", (PyCFunction)_wrap_gedit_panel_add_item, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "remove_item", (PyCFunction)_wrap_gedit_panel_remove_item, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "activate_item", (PyCFunction)_wrap_gedit_panel_activate_item, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "item_is_active", (PyCFunction)_wrap_gedit_panel_item_is_active, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_orientation", (PyCFunction)_wrap_gedit_panel_get_orientation, METH_NOARGS,
      NULL },
    { "get_n_items", (PyCFunction)_wrap_gedit_panel_get_n_items, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyGeditPanel_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "gedit.Panel",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyGeditPanel_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gedit_panel_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- GeditPlugin ----------- */

static PyObject *
_wrap_gedit_plugin_get_install_dir(PyGObject *self)
{
    gchar *ret;

    
    ret = gedit_plugin_get_install_dir(GEDIT_PLUGIN(self->obj));
    
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_plugin_get_data_dir(PyGObject *self)
{
    gchar *ret;

    
    ret = gedit_plugin_get_data_dir(GEDIT_PLUGIN(self->obj));
    
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

#line 7 "geditplugin.override"
static PyObject *
_wrap_gedit_plugin_activate(PyGObject *self, PyObject *args, PyObject *kwargs)
{
	gpointer klass, klass2;
	static char *kwlist[] = { "window", NULL };
	PyGObject *window;
	PyObject *cls = (PyObject *)(((PyObject *)self)->ob_type);
	
	if (!PyArg_ParseTupleAndKeywords (args, 
					  kwargs,
					  "O!:GeditPlugin.activate", 
					  kwlist,
					  &PyGeditWindow_Type, 
					  &window))
		return NULL;

	klass = g_type_class_ref (pyg_type_from_object (cls));
	
	if (GEDIT_IS_PLUGIN_PYTHON_CLASS (klass))
	{
		klass2 = g_type_class_peek_parent (klass);
		g_type_class_unref (klass);
		klass = g_type_class_ref (G_TYPE_FROM_CLASS (klass2));
	}

	if (GEDIT_PLUGIN_CLASS (klass)->activate)
		GEDIT_PLUGIN_CLASS (klass)->activate (GEDIT_PLUGIN (self->obj), 
						      GEDIT_WINDOW (window->obj));
	else {
		PyErr_SetString (PyExc_NotImplementedError, 
				 "virtual method GeditPlugin.activate not implemented");
		g_type_class_unref (klass);
		return NULL;
	}

	g_type_class_unref (klass);
	Py_INCREF(Py_None);
	return Py_None;
}

#line 2444 "gedit.c"


#line 49 "geditplugin.override"
static PyObject *
_wrap_gedit_plugin_deactivate(PyGObject *self, PyObject *args, PyObject *kwargs)
{
	gpointer klass, klass2;
	static char *kwlist[] = {"window", NULL};
	PyGObject *window;
	PyObject *cls = (PyObject *)(((PyObject *)self)->ob_type);

	if (!PyArg_ParseTupleAndKeywords (args, 
					  kwargs,
					  "O!:GeditPlugin.deactivate", 
					  kwlist,
					  &PyGeditWindow_Type, 
					  &window))
		return NULL;

	klass = g_type_class_ref (pyg_type_from_object (cls));

	if (GEDIT_IS_PLUGIN_PYTHON_CLASS (klass))
	{
		klass2 = g_type_class_peek_parent (klass);
		g_type_class_unref (klass);
		klass = g_type_class_ref (G_TYPE_FROM_CLASS (klass2));
	}
	
	if (GEDIT_PLUGIN_CLASS (klass)->deactivate)
		GEDIT_PLUGIN_CLASS (klass)->deactivate (GEDIT_PLUGIN (self->obj), 
							GEDIT_WINDOW (window->obj));
	else {
		PyErr_SetString (PyExc_NotImplementedError, 
				 "virtual method GeditPlugin.deactivate not implemented");
		g_type_class_unref (klass);
		return NULL;
	}

	g_type_class_unref (klass);
	Py_INCREF(Py_None);
	return Py_None;
}

#line 2488 "gedit.c"


#line 91 "geditplugin.override"
static PyObject *
_wrap_gedit_plugin_update_ui (PyGObject *self, PyObject *args, PyObject *kwargs)
{
	gpointer klass, klass2;
	static char *kwlist[] = {"window", NULL};
	PyGObject *window;
	PyObject *cls = (PyObject *)(((PyObject *)self)->ob_type);

	if (!PyArg_ParseTupleAndKeywords (args, 
					  kwargs,
					  "O!:GeditPlugin.update_ui", 
					  kwlist,
					  &PyGeditWindow_Type, 
					  &window))
		return NULL;

	klass = g_type_class_ref (pyg_type_from_object (cls));

	if (GEDIT_IS_PLUGIN_PYTHON_CLASS (klass))
	{
		klass2 = g_type_class_peek_parent (klass);
		g_type_class_unref (klass);
		klass = g_type_class_ref (G_TYPE_FROM_CLASS (klass2));
	}
	
	if (GEDIT_PLUGIN_CLASS (klass)->update_ui)
		GEDIT_PLUGIN_CLASS (klass)->update_ui (GEDIT_PLUGIN (self->obj), 
						       GEDIT_WINDOW (window->obj));
	else {
		PyErr_SetString (PyExc_NotImplementedError, 
				 "virtual method GeditPlugin.update_ui not implemented");
		g_type_class_unref (klass);
		return NULL;
	}

	g_type_class_unref (klass);
	Py_INCREF(Py_None);
	return Py_None;
}

#line 2532 "gedit.c"


#line 133 "geditplugin.override"
static PyObject *
_wrap_gedit_plugin_is_configurable (PyGObject *self)
{
	int ret;
	gpointer klass, klass2;
	PyObject *cls = (PyObject *)(((PyObject *)self)->ob_type);

	klass = g_type_class_ref (pyg_type_from_object (cls));

	if (GEDIT_IS_PLUGIN_PYTHON_CLASS (klass))
	{
		klass2 = g_type_class_peek_parent (klass);
		g_type_class_unref (klass);
		klass = g_type_class_ref (G_TYPE_FROM_CLASS (klass2));
	}
	
	if (GEDIT_PLUGIN_CLASS (klass)->is_configurable)
		ret = GEDIT_PLUGIN_CLASS (klass)->is_configurable (GEDIT_PLUGIN (self->obj));
	else {
		PyErr_SetString (PyExc_NotImplementedError, 
				 "virtual method GeditPlugin.is_configurable not implemented");
		g_type_class_unref (klass);
		return NULL;
	}

	g_type_class_unref (klass);
	return PyBool_FromLong (ret);
}

#line 2565 "gedit.c"


static PyObject *
_wrap_gedit_plugin_create_configure_dialog(PyGObject *self)
{
    GtkWidget *ret;

    
    ret = gedit_plugin_create_configure_dialog(GEDIT_PLUGIN(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static const PyMethodDef _PyGeditPlugin_methods[] = {
    { "get_install_dir", (PyCFunction)_wrap_gedit_plugin_get_install_dir, METH_NOARGS,
      NULL },
    { "get_data_dir", (PyCFunction)_wrap_gedit_plugin_get_data_dir, METH_NOARGS,
      NULL },
    { "activate", (PyCFunction)_wrap_gedit_plugin_activate, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "deactivate", (PyCFunction)_wrap_gedit_plugin_deactivate, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "update_ui", (PyCFunction)_wrap_gedit_plugin_update_ui, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "is_configurable", (PyCFunction)_wrap_gedit_plugin_is_configurable, METH_VARARGS,
      NULL },
    { "create_configure_dialog", (PyCFunction)_wrap_gedit_plugin_create_configure_dialog, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyGeditPlugin_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "gedit.__Plugin",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyGeditPlugin_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)0,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- GeditPluginPython ----------- */

static int
_wrap_gedit_plugin_python_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char* kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                     ":gedit.Plugin.__init__",
                                     kwlist))
        return -1;

    pygobject_constructv(self, 0, NULL);
    if (!self->obj) {
        PyErr_SetString(
            PyExc_RuntimeError, 
            "could not create gedit.Plugin object");
        return -1;
    }
    return 0;
}

PyTypeObject G_GNUC_INTERNAL PyGeditPluginPython_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "gedit.Plugin",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)NULL, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gedit_plugin_python_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- GeditStatusbar ----------- */

#line 446 "gedit.override"
static PyObject *
_wrap_gedit_statusbar_flash_message(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "context_id", "message", NULL };
    int context_id;
    char *message;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"is:GeditStatusbar.flash_message", kwlist, &context_id, &message))
        return NULL;
   
    gedit_statusbar_flash_message(GEDIT_STATUSBAR(self->obj), context_id, "%s", message);

    Py_INCREF(Py_None);
    return Py_None;
}
#line 2732 "gedit.c"


static const PyMethodDef _PyGeditStatusbar_methods[] = {
    { "flash_message", (PyCFunction)_wrap_gedit_statusbar_flash_message, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyGeditStatusbar_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "gedit.Statusbar",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyGeditStatusbar_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)0,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- GeditTab ----------- */

static PyObject *
_wrap_gedit_tab_get_view(PyGObject *self)
{
    GeditView *ret;

    
    ret = gedit_tab_get_view(GEDIT_TAB(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_tab_get_document(PyGObject *self)
{
    GeditDocument *ret;

    
    ret = gedit_tab_get_document(GEDIT_TAB(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_tab_get_state(PyGObject *self)
{
    gint ret;

    
    ret = gedit_tab_get_state(GEDIT_TAB(self->obj));
    
    return pyg_enum_from_gtype(GEDIT_TYPE_TAB_STATE, ret);
}

static PyObject *
_wrap_gedit_tab_set_auto_save_enabled(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "enable", NULL };
    int enable;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:Gedit.Tab.set_auto_save_enabled", kwlist, &enable))
        return NULL;
    
    gedit_tab_set_auto_save_enabled(GEDIT_TAB(self->obj), enable);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_tab_get_auto_save_enabled(PyGObject *self)
{
    int ret;

    
    ret = gedit_tab_get_auto_save_enabled(GEDIT_TAB(self->obj));
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_tab_set_auto_save_interval(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "interval", NULL };
    int interval;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:Gedit.Tab.set_auto_save_interval", kwlist, &interval))
        return NULL;
    
    gedit_tab_set_auto_save_interval(GEDIT_TAB(self->obj), interval);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_tab_get_auto_save_interval(PyGObject *self)
{
    int ret;

    
    ret = gedit_tab_get_auto_save_interval(GEDIT_TAB(self->obj));
    
    return PyInt_FromLong(ret);
}

static const PyMethodDef _PyGeditTab_methods[] = {
    { "get_view", (PyCFunction)_wrap_gedit_tab_get_view, METH_NOARGS,
      NULL },
    { "get_document", (PyCFunction)_wrap_gedit_tab_get_document, METH_NOARGS,
      NULL },
    { "get_state", (PyCFunction)_wrap_gedit_tab_get_state, METH_NOARGS,
      NULL },
    { "set_auto_save_enabled", (PyCFunction)_wrap_gedit_tab_set_auto_save_enabled, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_auto_save_enabled", (PyCFunction)_wrap_gedit_tab_get_auto_save_enabled, METH_NOARGS,
      NULL },
    { "set_auto_save_interval", (PyCFunction)_wrap_gedit_tab_set_auto_save_interval, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_auto_save_interval", (PyCFunction)_wrap_gedit_tab_get_auto_save_interval, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyGeditTab_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "gedit.Tab",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyGeditTab_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)0,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- GeditView ----------- */

static int
_wrap_gedit_view_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "doc", NULL };
    PyGObject *doc;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:Gedit.View.__init__", kwlist, &PyGeditDocument_Type, &doc))
        return -1;
    self->obj = (GObject *)gedit_view_new(GEDIT_DOCUMENT(doc->obj));

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GeditView object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gedit_view_cut_clipboard(PyGObject *self)
{
    
    gedit_view_cut_clipboard(GEDIT_VIEW(self->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_view_copy_clipboard(PyGObject *self)
{
    
    gedit_view_copy_clipboard(GEDIT_VIEW(self->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_view_paste_clipboard(PyGObject *self)
{
    
    gedit_view_paste_clipboard(GEDIT_VIEW(self->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_view_delete_selection(PyGObject *self)
{
    
    gedit_view_delete_selection(GEDIT_VIEW(self->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_view_select_all(PyGObject *self)
{
    
    gedit_view_select_all(GEDIT_VIEW(self->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_view_scroll_to_cursor(PyGObject *self)
{
    
    gedit_view_scroll_to_cursor(GEDIT_VIEW(self->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_view_set_font(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "def_", "font_name", NULL };
    int def;
    char *font_name;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"is:Gedit.View.set_font", kwlist, &def, &font_name))
        return NULL;
    
    gedit_view_set_font(GEDIT_VIEW(self->obj), def, font_name);
    
    Py_INCREF(Py_None);
    return Py_None;
}

static const PyMethodDef _PyGeditView_methods[] = {
    { "cut_clipboard", (PyCFunction)_wrap_gedit_view_cut_clipboard, METH_NOARGS,
      NULL },
    { "copy_clipboard", (PyCFunction)_wrap_gedit_view_copy_clipboard, METH_NOARGS,
      NULL },
    { "paste_clipboard", (PyCFunction)_wrap_gedit_view_paste_clipboard, METH_NOARGS,
      NULL },
    { "delete_selection", (PyCFunction)_wrap_gedit_view_delete_selection, METH_NOARGS,
      NULL },
    { "select_all", (PyCFunction)_wrap_gedit_view_select_all, METH_NOARGS,
      NULL },
    { "scroll_to_cursor", (PyCFunction)_wrap_gedit_view_scroll_to_cursor, METH_NOARGS,
      NULL },
    { "set_font", (PyCFunction)_wrap_gedit_view_set_font, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyGeditView_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "gedit.View",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyGeditView_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gedit_view_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- GeditWindow ----------- */

static PyObject *
_wrap_gedit_window_create_tab(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "jump_to", NULL };
    int jump_to;
    GeditTab *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:Gedit.Window.create_tab", kwlist, &jump_to))
        return NULL;
    
    ret = gedit_window_create_tab(GEDIT_WINDOW(self->obj), jump_to);
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_window_create_tab_from_uri(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "uri", "encoding", "line_pos", "create", "jump_to", NULL };
    char *uri;
    GeditEncoding *encoding = NULL;
    int line_pos, create, jump_to;
    GeditTab *ret;
    PyObject *py_encoding = Py_None;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"sOiii:Gedit.Window.create_tab_from_uri", kwlist, &uri, &py_encoding, &line_pos, &create, &jump_to))
        return NULL;
    if (pyg_boxed_check(py_encoding, GEDIT_TYPE_ENCODING))
        encoding = pyg_boxed_get(py_encoding, GeditEncoding);
    else if (py_encoding != Py_None) {
        PyErr_SetString(PyExc_TypeError, "encoding should be a GeditEncoding or None");
        return NULL;
    }
    
    ret = gedit_window_create_tab_from_uri(GEDIT_WINDOW(self->obj), uri, encoding, line_pos, create, jump_to);
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_window_close_tab(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "tab", NULL };
    PyGObject *tab;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:Gedit.Window.close_tab", kwlist, &PyGeditTab_Type, &tab))
        return NULL;
    
    gedit_window_close_tab(GEDIT_WINDOW(self->obj), GEDIT_TAB(tab->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

#line 202 "gedit.override"
static PyObject *
_wrap_gedit_window_close_tabs (PyGObject *self,
			       PyObject  *args,
			       PyObject  *kwargs)
{
	static char *kwlist[] = { "tabs", NULL };
	PyObject *list, *item;
	GList *glist = NULL;
	int len, i;

	if (!PyArg_ParseTupleAndKeywords (args, kwargs,
					  "O:GeditWindow.close_tabs", kwlist,
					  &list))
		return NULL;

	if (!PySequence_Check (list))
	{
		PyErr_SetString (PyExc_TypeError,
				 "first argument must be a sequence");
		return NULL;
	}

	len = PySequence_Length (list);

	for (i = 0; i < len; i++)
	{
		item = PySequence_GetItem (list, i);
		Py_DECREF(item);

		if (!pygobject_check (item, &PyGeditTab_Type))
		{
			PyErr_SetString (PyExc_TypeError,
					 "sequence item not a Gtkwidget object");
			g_list_free (glist);
			return NULL;
		}

		glist = g_list_append (glist, pygobject_get (item));
	}

	gedit_window_close_tabs (GEDIT_WINDOW (self->obj), glist);

	g_list_free (glist);
	Py_INCREF (Py_None);
	return Py_None;
}
#line 3209 "gedit.c"


static PyObject *
_wrap_gedit_window_close_all_tabs(PyGObject *self)
{
    
    gedit_window_close_all_tabs(GEDIT_WINDOW(self->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_window_get_active_tab(PyGObject *self)
{
    GeditTab *ret;

    
    ret = gedit_window_get_active_tab(GEDIT_WINDOW(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_window_set_active_tab(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "tab", NULL };
    PyGObject *tab;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:Gedit.Window.set_active_tab", kwlist, &PyGeditTab_Type, &tab))
        return NULL;
    
    gedit_window_set_active_tab(GEDIT_WINDOW(self->obj), GEDIT_TAB(tab->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_window_get_active_view(PyGObject *self)
{
    GeditView *ret;

    
    ret = gedit_window_get_active_view(GEDIT_WINDOW(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_window_get_active_document(PyGObject *self)
{
    GeditDocument *ret;

    
    ret = gedit_window_get_active_document(GEDIT_WINDOW(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

#line 154 "gedit.override"
static PyObject *
_wrap_gedit_window_get_documents(PyGObject *self)
{
    GList *list;
    PyObject *py_list;

    list = gedit_window_get_documents (GEDIT_WINDOW (self->obj));

    py_list = _helper_wrap_gobject_glist (list);

    g_list_free(list);

    return py_list;
}
#line 3288 "gedit.c"


#line 170 "gedit.override"
static PyObject *
_wrap_gedit_window_get_unsaved_documents(PyGObject *self)
{
    GList *list;
    PyObject *py_list;

    list = gedit_window_get_unsaved_documents (GEDIT_WINDOW (self->obj));

    py_list = _helper_wrap_gobject_glist (list);

    g_list_free(list);

    return py_list;
}
#line 3306 "gedit.c"


#line 186 "gedit.override"
static PyObject *
_wrap_gedit_window_get_views(PyGObject *self)
{
    GList *list;
    PyObject *py_list;

    list = gedit_window_get_views (GEDIT_WINDOW (self->obj));

    py_list = _helper_wrap_gobject_glist (list);

    g_list_free(list);

    return py_list;
}
#line 3324 "gedit.c"


static PyObject *
_wrap_gedit_window_get_group(PyGObject *self)
{
    GtkWindowGroup *ret;

    
    ret = gedit_window_get_group(GEDIT_WINDOW(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_window_get_side_panel(PyGObject *self)
{
    GeditPanel *ret;

    
    ret = gedit_window_get_side_panel(GEDIT_WINDOW(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_window_get_bottom_panel(PyGObject *self)
{
    GeditPanel *ret;

    
    ret = gedit_window_get_bottom_panel(GEDIT_WINDOW(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_window_get_statusbar(PyGObject *self)
{
    GtkWidget *ret;

    
    ret = gedit_window_get_statusbar(GEDIT_WINDOW(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_window_get_ui_manager(PyGObject *self)
{
    GtkUIManager *ret;

    
    ret = gedit_window_get_ui_manager(GEDIT_WINDOW(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_window_get_state(PyGObject *self)
{
    guint ret;

    
    ret = gedit_window_get_state(GEDIT_WINDOW(self->obj));
    
    return pyg_flags_from_gtype(GEDIT_TYPE_WINDOW_STATE, ret);
}

static PyObject *
_wrap_gedit_window_get_message_bus(PyGObject *self)
{
    GeditMessageBus *ret;

    
    ret = gedit_window_get_message_bus(GEDIT_WINDOW(self->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_window_get_tab_from_uri(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "uri", NULL };
    char *uri;
    GeditTab *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:Gedit.Window.get_tab_from_uri", kwlist, &uri))
        return NULL;
    
    ret = gedit_window_get_tab_from_uri(GEDIT_WINDOW(self->obj), uri);
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static const PyMethodDef _PyGeditWindow_methods[] = {
    { "create_tab", (PyCFunction)_wrap_gedit_window_create_tab, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "create_tab_from_uri", (PyCFunction)_wrap_gedit_window_create_tab_from_uri, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "close_tab", (PyCFunction)_wrap_gedit_window_close_tab, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "close_tabs", (PyCFunction)_wrap_gedit_window_close_tabs, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "close_all_tabs", (PyCFunction)_wrap_gedit_window_close_all_tabs, METH_NOARGS,
      NULL },
    { "get_active_tab", (PyCFunction)_wrap_gedit_window_get_active_tab, METH_NOARGS,
      NULL },
    { "set_active_tab", (PyCFunction)_wrap_gedit_window_set_active_tab, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_active_view", (PyCFunction)_wrap_gedit_window_get_active_view, METH_NOARGS,
      NULL },
    { "get_active_document", (PyCFunction)_wrap_gedit_window_get_active_document, METH_NOARGS,
      NULL },
    { "get_documents", (PyCFunction)_wrap_gedit_window_get_documents, METH_VARARGS,
      NULL },
    { "get_unsaved_documents", (PyCFunction)_wrap_gedit_window_get_unsaved_documents, METH_VARARGS,
      NULL },
    { "get_views", (PyCFunction)_wrap_gedit_window_get_views, METH_VARARGS,
      NULL },
    { "get_group", (PyCFunction)_wrap_gedit_window_get_group, METH_NOARGS,
      NULL },
    { "get_side_panel", (PyCFunction)_wrap_gedit_window_get_side_panel, METH_NOARGS,
      NULL },
    { "get_bottom_panel", (PyCFunction)_wrap_gedit_window_get_bottom_panel, METH_NOARGS,
      NULL },
    { "get_statusbar", (PyCFunction)_wrap_gedit_window_get_statusbar, METH_NOARGS,
      NULL },
    { "get_ui_manager", (PyCFunction)_wrap_gedit_window_get_ui_manager, METH_NOARGS,
      NULL },
    { "get_state", (PyCFunction)_wrap_gedit_window_get_state, METH_NOARGS,
      NULL },
    { "get_message_bus", (PyCFunction)_wrap_gedit_window_get_message_bus, METH_NOARGS,
      NULL },
    { "get_tab_from_uri", (PyCFunction)_wrap_gedit_window_get_tab_from_uri, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject G_GNUC_INTERNAL PyGeditWindow_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "gedit.Window",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyGeditWindow_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)0,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- functions ----------- */

static PyObject *
_wrap_gedit_app_get_default(PyObject *self)
{
    GeditApp *ret;

    
    ret = gedit_app_get_default();
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

#line 304 "gedit.override"
/* deprecated wrappers */
static PyObject *
_wrap_gedit_app_get_default_deprecated(PyObject *self)
{
    if (PyErr_Warn(PyExc_DeprecationWarning, "use gedit.app_get_default instead") < 0)
	return NULL;
    return _wrap_gedit_app_get_default(self);
}
#line 3540 "gedit.c"


static PyObject *
_wrap_gedit_encoding_get_from_charset(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "charset", NULL };
    char *charset;
    const GeditEncoding *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:encoding_get_from_charset", kwlist, &charset))
        return NULL;
    
    ret = gedit_encoding_get_from_charset(charset);
    
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(GEDIT_TYPE_ENCODING, (GeditEncoding*) ret, TRUE, TRUE);
}

#line 314 "gedit.override"
static PyObject *
_wrap_gedit_encoding_get_from_charset_deprecated(PyObject *self, PyObject *args, PyObject *kwargs)
{
    if (PyErr_Warn(PyExc_DeprecationWarning, "use gedit.encoding_get_from_charset instead") < 0)
	return NULL;
    return _wrap_gedit_encoding_get_from_charset(self, args, kwargs);
}
#line 3567 "gedit.c"


static PyObject *
_wrap_gedit_encoding_get_from_index(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "index", NULL };
    int index;
    const GeditEncoding *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"i:encoding_get_from_index", kwlist, &index))
        return NULL;
    
    ret = gedit_encoding_get_from_index(index);
    
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(GEDIT_TYPE_ENCODING, (GeditEncoding*) ret, TRUE, TRUE);
}

#line 323 "gedit.override"
static PyObject *
_wrap_gedit_encoding_get_from_index_deprecated(PyObject *self, PyObject *args, PyObject *kwargs)
{
    if (PyErr_Warn(PyExc_DeprecationWarning, "use gedit.encoding_get_from_index instead") < 0)
	return NULL;
    return _wrap_gedit_encoding_get_from_index(self, args, kwargs);
}
#line 3594 "gedit.c"


static PyObject *
_wrap_gedit_encoding_get_utf8(PyObject *self)
{
    const GeditEncoding *ret;

    
    ret = gedit_encoding_get_utf8();
    
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(GEDIT_TYPE_ENCODING, (GeditEncoding*) ret, TRUE, TRUE);
}

#line 332 "gedit.override"
static PyObject *
_wrap_gedit_encoding_get_utf8_deprecated(PyObject *self)
{
    if (PyErr_Warn(PyExc_DeprecationWarning, "use gedit.encoding_get_utf8 instead") < 0)
	return NULL;
    return _wrap_gedit_encoding_get_utf8(self);
}
#line 3617 "gedit.c"


static PyObject *
_wrap_gedit_encoding_get_current(PyObject *self)
{
    const GeditEncoding *ret;

    
    ret = gedit_encoding_get_current();
    
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(GEDIT_TYPE_ENCODING, (GeditEncoding*) ret, TRUE, TRUE);
}

#line 341 "gedit.override"
static PyObject *
_wrap_gedit_encoding_get_current_deprecated(PyObject *self)
{
    if (PyErr_Warn(PyExc_DeprecationWarning, "use gedit.encoding_get_current instead") < 0)
	return NULL;
    return _wrap_gedit_encoding_get_current(self);
}
#line 3640 "gedit.c"


static PyObject *
_wrap_gedit_help_display(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "parent", "name", "link_id", NULL };
    PyGObject *parent;
    char *name, *link_id;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!ss:help_display", kwlist, &PyGtkWindow_Type, &parent, &name, &link_id))
        return NULL;
    
    ret = gedit_help_display(GTK_WINDOW(parent->obj), name, link_id);
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_tab_get_from_document(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "doc", NULL };
    PyGObject *doc;
    GeditTab *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:tab_get_from_document", kwlist, &PyGeditDocument_Type, &doc))
        return NULL;
    
    ret = gedit_tab_get_from_document(GEDIT_DOCUMENT(doc->obj));
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

#line 350 "gedit.override"
static PyObject *
_wrap_gedit_tab_get_from_document_deprecated(PyObject *self, PyObject *args, PyObject *kwargs)
{
    if (PyErr_Warn(PyExc_DeprecationWarning, "use gedit.tab_get_from_document instead") < 0)
	return NULL;
    return _wrap_gedit_tab_get_from_document(self, args, kwargs);
}
#line 3684 "gedit.c"


static PyObject *
_wrap_gedit_get_language_manager(PyObject *self)
{
    GtkSourceLanguageManager *ret;

    
    ret = gedit_get_language_manager();
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

#line 359 "gedit.override"
static PyObject *
_wrap_gedit_language_manager_list_languages_sorted(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "lm", "include_hidden", NULL };
    PyGObject *lm;
    int include_hidden;
    PyObject *py_list;
    GSList *list;

    if (!PyArg_ParseTupleAndKeywords (args, kwargs,
                                      "O!i:language_manager_list_languages_sorted",
                                      kwlist, &PyGtkSourceLanguageManager_Type, &lm,
                                      &include_hidden))
        return NULL;

    list = gedit_language_manager_list_languages_sorted (GTK_SOURCE_LANGUAGE_MANAGER (lm->obj),
                                                         include_hidden);

    py_list = _helper_wrap_gobject_gslist (list);

    g_slist_free (list);

    return py_list;
}
#line 3724 "gedit.c"


static PyObject *
_wrap_gedit_message_bus_get_default(PyObject *self)
{
    GeditMessageBus *ret;

    
    ret = gedit_message_bus_get_default();
    
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gedit_message_type_is_supported(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "type", NULL };
    PyObject *py_type = NULL;
    int ret;
    GType type;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:gedit_message_type_is_supported", kwlist, &py_type))
        return NULL;
    if ((type = pyg_type_from_object(py_type)) == 0)
        return NULL;
    
    ret = gedit_message_type_is_supported(type);
    
    return PyBool_FromLong(ret);

}

static PyObject *
_wrap_gedit_message_type_identifier(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "object_path", "method", NULL };
    char *object_path, *method;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"ss:gedit_message_type_identifier", kwlist, &object_path, &method))
        return NULL;
    
    ret = gedit_message_type_identifier(object_path, method);
    
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

#line 385 "gedit.override"
static PyObject *
_wrap_gedit_debug(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "message", NULL };
    PyObject *traceback_module, *mdict, *func, *traceback, *tuple;
    PyObject *filename, *lineno, *funcname;
    char *message = NULL;

    if (g_getenv ("GEDIT_DEBUG_PLUGINS") == NULL)
    {
        Py_INCREF (Py_None);
        return Py_None;
    }

    if (!PyArg_ParseTupleAndKeywords (args, kwargs, "|s", kwlist, &message))
        return NULL;

    traceback_module = PyImport_ImportModule ("traceback");
    if (traceback_module == NULL)
    {
        g_warning ("traceback module cannot be imported");
        Py_INCREF (Py_None);
        return Py_None;
    }

    mdict = PyModule_GetDict (traceback_module);
    func = PyDict_GetItemString (mdict, "extract_stack");
    traceback = PyObject_CallFunction (func, "zi", NULL, 1);
    tuple = PyList_GetItem (traceback, 0);

    if (tuple == NULL || !PyTuple_Check (tuple))
    {
        g_warning ("traceback tuple is null!");
    }
    else
    {
        filename = PyTuple_GetItem (tuple, 0);
        lineno = PyTuple_GetItem (tuple, 1);
        funcname = PyTuple_GetItem (tuple, 2);

        if (message == NULL)
            gedit_debug (GEDIT_DEBUG_PLUGINS,
                         PyString_AsString (filename),
                         PyInt_AsLong (lineno),
                         PyString_AsString (funcname));
        else
            gedit_debug_message (GEDIT_DEBUG_PLUGINS,
                                 PyString_AsString (filename),
                                 PyInt_AsLong (lineno),
                                 PyString_AsString (funcname),
                                 "%s",
                                 message);
    }
    Py_DECREF (traceback);
    Py_DECREF (traceback_module);

    Py_INCREF (Py_None);
    return Py_None;
}
#line 3839 "gedit.c"


const PyMethodDef pygedit_functions[] = {
    { "app_get_default", (PyCFunction)_wrap_gedit_app_get_default, METH_NOARGS,
      NULL },
    { "gedit_app_get_default", (PyCFunction)_wrap_gedit_app_get_default_deprecated, METH_VARARGS,
      NULL },
    { "encoding_get_from_charset", (PyCFunction)_wrap_gedit_encoding_get_from_charset, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "gedit_encoding_get_from_charset", (PyCFunction)_wrap_gedit_encoding_get_from_charset_deprecated, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "encoding_get_from_index", (PyCFunction)_wrap_gedit_encoding_get_from_index, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "gedit_encoding_get_from_index", (PyCFunction)_wrap_gedit_encoding_get_from_index_deprecated, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "encoding_get_utf8", (PyCFunction)_wrap_gedit_encoding_get_utf8, METH_NOARGS,
      NULL },
    { "gedit_encoding_get_utf8", (PyCFunction)_wrap_gedit_encoding_get_utf8_deprecated, METH_VARARGS,
      NULL },
    { "encoding_get_current", (PyCFunction)_wrap_gedit_encoding_get_current, METH_NOARGS,
      NULL },
    { "gedit_encoding_get_current", (PyCFunction)_wrap_gedit_encoding_get_current_deprecated, METH_VARARGS,
      NULL },
    { "help_display", (PyCFunction)_wrap_gedit_help_display, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "tab_get_from_document", (PyCFunction)_wrap_gedit_tab_get_from_document, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "gedit_tab_get_from_document", (PyCFunction)_wrap_gedit_tab_get_from_document_deprecated, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_language_manager", (PyCFunction)_wrap_gedit_get_language_manager, METH_NOARGS,
      NULL },
    { "language_manager_list_languages_sorted", (PyCFunction)_wrap_gedit_language_manager_list_languages_sorted, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "message_bus_get_default", (PyCFunction)_wrap_gedit_message_bus_get_default, METH_NOARGS,
      NULL },
    { "gedit_message_type_is_supported", (PyCFunction)_wrap_gedit_message_type_is_supported, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "gedit_message_type_identifier", (PyCFunction)_wrap_gedit_message_type_identifier, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "debug", (PyCFunction)_wrap_gedit_debug, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};


/* ----------- enums and flags ----------- */

void
pygedit_add_constants(PyObject *module, const gchar *strip_prefix)
{
#ifdef VERSION
    PyModule_AddStringConstant(module, "__version__", VERSION);
#endif
  pyg_flags_add(module, "LockdownMask", strip_prefix, GEDIT_TYPE_LOCKDOWN_MASK);
  pyg_flags_add(module, "SearchFlags", strip_prefix, GEDIT_TYPE_SEARCH_FLAGS);
  pyg_flags_add(module, "DocumentSaveFlags", strip_prefix, GEDIT_TYPE_DOCUMENT_SAVE_FLAGS);
  pyg_enum_add(module, "TabState", strip_prefix, GEDIT_TYPE_TAB_STATE);
  pyg_flags_add(module, "WindowState", strip_prefix, GEDIT_TYPE_WINDOW_STATE);

  if (PyErr_Occurred())
    PyErr_Print();
}

/* initialise stuff extension classes */
void
pygedit_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        _PyGObject_Type = (PyTypeObject *)PyObject_GetAttrString(module, "GObject");
        if (_PyGObject_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name GObject from gobject");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gobject");
        return ;
    }
    if ((module = PyImport_ImportModule("gtk")) != NULL) {
        _PyGtkWidget_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Widget");
        if (_PyGtkWidget_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Widget from gtk");
            return ;
        }
        _PyGtkVBox_Type = (PyTypeObject *)PyObject_GetAttrString(module, "VBox");
        if (_PyGtkVBox_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name VBox from gtk");
            return ;
        }
        _PyGtkWindow_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Window");
        if (_PyGtkWindow_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Window from gtk");
            return ;
        }
        _PyGtkImage_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Image");
        if (_PyGtkImage_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Image from gtk");
            return ;
        }
        _PyGtkStatusbar_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Statusbar");
        if (_PyGtkStatusbar_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Statusbar from gtk");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gtk");
        return ;
    }
    if ((module = PyImport_ImportModule("gtksourceview2")) != NULL) {
        _PyGtkSourceBuffer_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Buffer");
        if (_PyGtkSourceBuffer_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Buffer from gtksourceview2");
            return ;
        }
        _PyGtkSourceView_Type = (PyTypeObject *)PyObject_GetAttrString(module, "View");
        if (_PyGtkSourceView_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name View from gtksourceview2");
            return ;
        }
        _PyGtkSourceLanguage_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Language");
        if (_PyGtkSourceLanguage_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Language from gtksourceview2");
            return ;
        }
        _PyGtkSourceLanguageManager_Type = (PyTypeObject *)PyObject_GetAttrString(module, "LanguageManager");
        if (_PyGtkSourceLanguageManager_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name LanguageManager from gtksourceview2");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gtksourceview2");
        return ;
    }
    if ((module = PyImport_ImportModule("gtk.gdk")) != NULL) {
        _PyGdkScreen_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Screen");
        if (_PyGdkScreen_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Screen from gtk.gdk");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gtk.gdk");
        return ;
    }


#line 4001 "gedit.c"
    pyg_register_boxed(d, "Encoding", GEDIT_TYPE_ENCODING, &PyGeditEncoding_Type);
    pyg_register_boxed(d, "MessageType", GEDIT_TYPE_MESSAGE_TYPE, &PyGeditMessageType_Type);
    pygobject_register_class(d, "GeditApp", GEDIT_TYPE_APP, &PyGeditApp_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pyg_set_object_has_new_constructor(GEDIT_TYPE_APP);
    pygobject_register_class(d, "GeditDocument", GEDIT_TYPE_DOCUMENT, &PyGeditDocument_Type, Py_BuildValue("(O)", &PyGtkSourceBuffer_Type));
    pyg_set_object_has_new_constructor(GEDIT_TYPE_DOCUMENT);
    pygobject_register_class(d, "GeditMessage", GEDIT_TYPE_MESSAGE, &PyGeditMessage_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pyg_set_object_has_new_constructor(GEDIT_TYPE_MESSAGE);
    pygobject_register_class(d, "GeditMessageBus", GEDIT_TYPE_MESSAGE_BUS, &PyGeditMessageBus_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pyg_set_object_has_new_constructor(GEDIT_TYPE_MESSAGE_BUS);
    pygobject_register_class(d, "GeditPanel", GEDIT_TYPE_PANEL, &PyGeditPanel_Type, Py_BuildValue("(O)", &PyGtkVBox_Type));
    pyg_set_object_has_new_constructor(GEDIT_TYPE_PANEL);
    pygobject_register_class(d, "GeditPlugin", GEDIT_TYPE_PLUGIN, &PyGeditPlugin_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pyg_set_object_has_new_constructor(GEDIT_TYPE_PLUGIN);
    pygobject_register_class(d, "GeditPluginPython", GEDIT_TYPE_PLUGIN_PYTHON, &PyGeditPluginPython_Type, Py_BuildValue("(O)", &PyGeditPlugin_Type));
    pyg_set_object_has_new_constructor(GEDIT_TYPE_PLUGIN_PYTHON);
    pygobject_register_class(d, "GeditStatusbar", GEDIT_TYPE_STATUSBAR, &PyGeditStatusbar_Type, Py_BuildValue("(O)", &PyGtkStatusbar_Type));
    pygobject_register_class(d, "GeditTab", GEDIT_TYPE_TAB, &PyGeditTab_Type, Py_BuildValue("(O)", &PyGtkVBox_Type));
    pygobject_register_class(d, "GeditView", GEDIT_TYPE_VIEW, &PyGeditView_Type, Py_BuildValue("(O)", &PyGtkSourceView_Type));
    pygobject_register_class(d, "GeditWindow", GEDIT_TYPE_WINDOW, &PyGeditWindow_Type, Py_BuildValue("(O)", &PyGtkWindow_Type));
}
