/* -- THIS FILE IS GENERATED - DO NOT EDIT *//* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 3 "geditcommands.override"
#define NO_IMPORT_PYGOBJECT
#define NO_IMPORT_PYGTK
#include <pygobject.h>
#include <pygtk/pygtk.h>

#include "gedit-commands.h"
#include "gedit-window.h"

void pygeditcommands_register_classes (PyObject *d);
void pygeditcommands_add_constants (PyObject *module, const gchar *strip_prefix);

#line 20 "geditcommands.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGeditWindow_Type;
#define PyGeditWindow_Type (*_PyGeditWindow_Type)
static PyTypeObject *_PyGeditDocument_Type;
#define PyGeditDocument_Type (*_PyGeditDocument_Type)


/* ---------- forward type declarations ---------- */

#line 32 "geditcommands.c"



/* ----------- functions ----------- */

#line 24 "geditcommands.override"
static PyObject *
_wrap_gedit_commands_load_uri (PyObject *self, PyObject *args, PyObject *kwargs)
{
	static char *kwlist[] = { "window", "uri", "encoding", "line_pos", NULL };
	PyGObject *window;
	char *uri;
	int line_pos = 0;
	PyObject *py_encoding = NULL;
	GeditEncoding *encoding = NULL;

	if (!PyArg_ParseTupleAndKeywords (args, kwargs, "O!s|Oi:load_uri", 
	                                  kwlist, &PyGeditWindow_Type, 
	                                  &window, &uri, &py_encoding, 
	                                  &line_pos))
		return NULL;
    
	if (py_encoding != NULL && py_encoding != Py_None)
	{
		if (pyg_boxed_check (py_encoding, GEDIT_TYPE_ENCODING))
			encoding = pyg_boxed_get (py_encoding, GeditEncoding);
		else
		{
			PyErr_SetString (PyExc_TypeError, 
			                 "encoding should be a GeditEncoding");
			return NULL;
		}
	}

	gedit_commands_load_uri (GEDIT_WINDOW (window->obj), uri, encoding, 
	                        line_pos);
	Py_INCREF (Py_None);
	return Py_None;
}
#line 72 "geditcommands.c"


#line 59 "geditcommands.override"
static PyObject *
_wrap_gedit_commands_load_uris (PyObject *self, PyObject *args, PyObject *kwargs)
{
	static char *kwlist[] = { "window", "uris", "encoding", "line_pos", NULL };
	PyGObject *window;
	GSList *uris = NULL;
	int line_pos = 0;
	PyObject *py_encoding = NULL;
	PyObject *list;
	PyObject *item;
	GeditEncoding *encoding = NULL;
	int len;
	int i;

	if (!PyArg_ParseTupleAndKeywords (args, kwargs, "O!O|Oi:load_uri", 
	                                  kwlist, &PyGeditWindow_Type, 
	                                  &window, &list, &py_encoding, 
	                                  &line_pos))
		return NULL;
    
	if (py_encoding != NULL && py_encoding != Py_None)
	{
		if (pyg_boxed_check (py_encoding, GEDIT_TYPE_ENCODING))
			encoding = pyg_boxed_get (py_encoding, GeditEncoding);
		else {
			PyErr_SetString (PyExc_TypeError, 
			                 "encoding should be a GeditEncoding");
			return NULL;
		}
	}

	if (!PySequence_Check (list))
	{
		PyErr_SetString (PyExc_TypeError, 
		                 "second argument must be a sequence");
		return NULL;
	}

	len = PySequence_Length (list);

	for (i = 0; i < len; i++)
	{
		item = PySequence_GetItem (list, i);
		Py_DECREF (item);

		if (!PyString_Check (item))
		{
			PyErr_SetString (PyExc_TypeError,
					 "sequence item not a string");
			g_slist_free (uris);
			return NULL;
		}

		uris = g_slist_prepend (uris, PyString_AsString (item));
	}

	uris = g_slist_reverse (uris);
	gedit_commands_load_uris (GEDIT_WINDOW (window->obj), uris, 
	                          encoding, line_pos);
	g_slist_free (uris);

	Py_INCREF (Py_None);
	return Py_None;
}
#line 140 "geditcommands.c"


static PyObject *
_wrap_gedit_commands_save_document(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "window", "document", NULL };
    PyGObject *window, *document;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!O!:save_document", kwlist, &PyGeditWindow_Type, &window, &PyGeditDocument_Type, &document))
        return NULL;
    
    gedit_commands_save_document(GEDIT_WINDOW(window->obj), GEDIT_DOCUMENT(document->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gedit_commands_save_all_documents(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "window", NULL };
    PyGObject *window;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:save_all_documents", kwlist, &PyGeditWindow_Type, &window))
        return NULL;
    
    gedit_commands_save_all_documents(GEDIT_WINDOW(window->obj));
    
    Py_INCREF(Py_None);
    return Py_None;
}

const PyMethodDef pygeditcommands_functions[] = {
    { "load_uri", (PyCFunction)_wrap_gedit_commands_load_uri, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "load_uris", (PyCFunction)_wrap_gedit_commands_load_uris, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "save_document", (PyCFunction)_wrap_gedit_commands_save_document, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "save_all_documents", (PyCFunction)_wrap_gedit_commands_save_all_documents, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};

/* initialise stuff extension classes */
void
pygeditcommands_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gedit")) != NULL) {
        _PyGeditWindow_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Window");
        if (_PyGeditWindow_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Window from gedit");
            return ;
        }
        _PyGeditDocument_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Document");
        if (_PyGeditDocument_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Document from gedit");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gedit");
        return ;
    }


#line 211 "geditcommands.c"
}
